﻿using System;
using System.Collections.Generic;
//using System.Linq;
using System.Text;

namespace TransportProblem
{
    public class Edge
    {
        protected long FirstVertex;
        protected long SecondVertex;
        protected long Weight;
        public Edge(Edge edge)
        {
            FirstVertex = edge.FirstVertex;
            SecondVertex = edge.SecondVertex;
            Weight = edge.Weight;
        }
        public Edge(long firstVertex, long secondVertex, long edgeWeight)
        {
            FirstVertex = firstVertex;
            SecondVertex = secondVertex;
            Weight = edgeWeight;
        }
        public Edge(long firstVertex, long secondVertex)
        {
            FirstVertex = firstVertex;
            SecondVertex = secondVertex;
            Weight = 0;
        }
        public void SetWeight(long edgeWeight)
        {
            Weight = edgeWeight;
        }
        public long GetWeight()
        {
            return Weight;
        }
        public long GetFirstVertex()
        {
            return FirstVertex;
        }
        public long GetSecondVertex()
        {
            return SecondVertex;
        }
        public void SetFirstVertex(long firstVertex)
        {
            FirstVertex = firstVertex;
        }
        public void SetSecondVertex(long secondVertex)
        {
            SecondVertex = secondVertex;
        }
        public void SetVertexes(long firstVertex, long secondVertex)
        {
            FirstVertex = firstVertex;
            SecondVertex = secondVertex;
        }
        public static bool operator ==(Edge a, Edge b)
        {
            if (a.FirstVertex == b.FirstVertex && a.SecondVertex == b.SecondVertex && a.Weight == b.Weight)
                return true;
            else
                return false;
        }
        public static bool operator !=(Edge a, Edge b)
        {
            return !(a == b);
        }
        public override string ToString()
        {
            return "(" + (FirstVertex + 1).ToString() + "," + (SecondVertex + 1).ToString() + ")";
        }
    }
}
