﻿using System;
using System.Collections.Generic;
//using System.Linq;
using System.Text;

namespace TransportProblem
{
    /*public class PotentialMethod
    {
        protected long[,] Matrix;
        protected long[,] Marks;
        protected bool[,] MarksBoolean;
        protected long[] Row;
        protected long[] Column;
        protected long[] RowPotentials;
        protected long[] ColumnPotentials;
        protected int VertexCount;
        public PotentialMethod(int vertexCount)
        {
            VertexCount = vertexCount;
            Matrix = new long[VertexCount, VertexCount];
            Marks = new long[VertexCount, VertexCount];
            MarksBoolean = new bool[VertexCount, VertexCount];
            Row = new long[VertexCount];
            RowPotentials = new long[VertexCount];
            Column = new long[VertexCount];
            ColumnPotentials = new long[VertexCount];
        }
        public void Generate(int min, int max)
        {
            Random rnd = new Random();
            for (int i = 0; i < VertexCount; i++)
                for (int j = 0; j < VertexCount; j++)
                    Matrix[i, j] = min + rnd.Next(max - min);
            List<long> list1 = new List<long>();
            List<long> list2 = new List<long>();
            long summa = 0;
            for (int i = 0; i < VertexCount; i++)
            {
                long value;
                value = (min + rnd.Next(Convert.ToInt32((max - min)))) * 10;
                list1.Add(value);
                summa += value;
            }
            for (int i = 0; i < VertexCount; i++)
            {
                Row[i] = list1[i];
                Column[i] = list1[VertexCount - i - 1];
            }
        }
        public void Prepare()
        {
            long[] row = new long[VertexCount];
            long[] column = new long[VertexCount];
            for (int i = 0; i < VertexCount; i++)
            {
                row[i] = Row[i];
                column[i] = Column[i];
            }
            int posX = 0, posY = 0;
            for (int k = 0; k < VertexCount * 2 - 1; k++)
            {
                if (column[posY] == 0)
                    posY++;
                else
                    if (row[posX] == 0)
                        posX++;
                long value = Math.Min(column[posY], row[posX]);
                Marks[posY, posX] = value;
                MarksBoolean[posY, posX] = true;
                column[posY] -= value;
                row[posX] -= value;
            }
        }
        public long GetValueOfTargetFunction()
        {
            long summa = 0;
            for (int i = 0; i < VertexCount; i++)
                for (int j = 0; j < VertexCount; j++)
                {
                    summa += Matrix[i, j] * Marks[i, j];
                }
            return summa;
        }
        public List<Edge> GetCurrentSolution()
        {
            List<Edge> list = new List<Edge>();
            for (int i = 0; i < VertexCount; i++)
                for (int j = 0; j < VertexCount; j++)
                {
                    if (Marks[i, j] != 0)
                    {
                        list.Add(new Edge(i, j));
                    }
                }
            return list;
        }
        public long this[long i, long j]
        {
            get
            {
                return Matrix[i, j];
            }
            set
            {
                Matrix[i, j] = value;
            }
        }
        public long GetLastRow(long i)
        {
            return Row[i];
        }
        public long GetLastColumn(long i)
        {
            return Column[i];
        }
        public void SetLastRow(long i, long value)
        {
            Row[i] = value;
        }
        public void SetLastColumn(long i, long value)
        {
            Column[i] = value;
        }
        public void FindPotentials()
        {
            bool[] row = new bool[VertexCount];
            bool[] column = new bool[VertexCount];
            row[0] = true;
            int count = 1;
            RowPotentials[0] = 0;            
            while (count < VertexCount * 2)
            {
                for (int i = 0; i < VertexCount; i++)
                    for (int j = 0; j < VertexCount; j++)
                    {
                        if (row[i] != column[j] && MarksBoolean[i, j])
                        {
                            if (row[i] == true && column[j] == false)
                            {
                                ColumnPotentials[j] = Matrix[i, j] - RowPotentials[i];
                                column[j] = true;
                                count++;
                            }
                            if (row[i] == false && column[j] == true)
                            {
                                RowPotentials[i] = Matrix[i, j] - ColumnPotentials[j];
                                row[i] = true;
                                count++;
                            }
                        }
                    }
            }

        }
        public Edge FindMaxMark()
        {
            long max = long.MinValue;
            Edge edge = null;
               for (int i = 0; i < VertexCount; i++)
                   for (int j = 0; j < VertexCount; j++)
                   {
                       if (MarksBoolean[i, j] == false)
                       {
                           long value;
                           value = RowPotentials[i] + ColumnPotentials[j] - Matrix[i, j];
                           if (value > max)
                           {
                               max = value;
                               edge = new Edge(i, j,value);
                           }
                       }
                   }
               return edge;
        }
        public void FindCylce()
        {
            bool[,] matrix = new bool[VertexCount, VertexCount];
            Edge edge = FindMaxMark();            
            for (int i = 0; i < VertexCount; i++)
                for (int j = 0; j < VertexCount; j++)
                    matrix[i, j] = MarksBoolean[i, j];
            matrix[edge.GetFirstVertex(), edge.GetSecondVertex()] = true;
            int countRow = 0, countCol = 0;
            bool f = true;
            while (f)
            {
                f = false;
                for (int i = 0; i < VertexCount; i++)
                {
                    countCol = 0;
                    countRow = 0;
                    for (int j = 0; j < VertexCount; j++)
                    {
                        if (matrix[j, i])
                            countCol++;
                        if (matrix[i, j])
                            countRow++;
                    }
                    if (countCol == 1)
                    {
                        for (int j = 0; j < VertexCount; j++)
                            matrix[j, i] = false;
                        f = true;
                    }
                    if (countRow == 1)
                    {
                        for (int j = 0; j < VertexCount; j++)
                            matrix[i, j] = false;
                        f = true;
                    }
                }
            }
            long posX, posY;
            posY = edge.GetFirstVertex();
            posX = edge.GetSecondVertex();
            string[,] signMatrix = new string[VertexCount, VertexCount];
            bool sign = true; // true - знак плюс, false - минус
            signMatrix[posY, posX] = "+";            
            do
            {
                for (int i = 0; i < VertexCount; i++)
                    if (i != posY)
                        if (matrix[i, posX] == true)
                        {
                            posY = i;
                            break;
                        }
                signMatrix[posY, posX] = "-";
                for (int i = 0; i < VertexCount; i++)
                    if (i != posX)
                        if (matrix[posY, i] == true)
                        {
                            posX = i;
                            break;
                        }
                signMatrix[posY, posX] = "+";
            } while (posY != edge.GetFirstVertex() && posX != edge.GetSecondVertex());
            
            long minMark = long.MaxValue;
            Edge minMarkEdge = null;
            for (int i = 0; i < VertexCount; i++)
                for (int j = 0; j < VertexCount; j++)
                {
                    if (signMatrix[i, j] == "-")
                    {
                        if (minMark > Marks[i, j])
                        {
                            minMark = Marks[i, j];
                            minMarkEdge = new Edge(i, j);
                        }
                    }
                }
             for (int i = 0; i < VertexCount; i++)
                 for (int j = 0; j < VertexCount; j++)
                 {
                     if (signMatrix[i, j] == "-")
                     {
                         MarksBoolean[posY, posX] = true;
                         Marks[i,j] -= minMark;
                     }
                     if (signMatrix[i, j] == "+")
                     {
                         MarksBoolean[posY, posX] = true;
                         Marks[i,j] += minMark;
                     }
                 }
             MarksBoolean[minMarkEdge.GetFirstVertex(), minMarkEdge.GetSecondVertex()] = false;
        }
        public bool DoIteration()
        {
            FindPotentials();
            Edge edge = FindMaxMark();
            if (edge.GetWeight() <= 0)
            {
                return false;
            }
            FindCylce();
            return true;
        }
    }*/
    public class PotentialMethod
    {
        protected long[,] Matrix;
        protected long[,] Marks;
        protected bool[,] MarksBoolean;
        protected int SourceRowCount;
        protected int SourceColCount;
        protected long[] Row;
        protected long[] Column;
        protected long[] RowPotentials;
        protected long[] ColumnPotentials;
        protected int RowCount;
        protected int ColCount;
        public PotentialMethod(int rowCount, int colCount)
        {
            RowCount = rowCount;
            ColCount = colCount;
            SourceRowCount = rowCount;
            SourceColCount = colCount;
            Matrix = new long[RowCount, ColCount];
            Marks = new long[RowCount, ColCount];
            MarksBoolean = new bool[RowCount, ColCount];
            Row = new long[ColCount];
            RowPotentials = new long[ColCount];
            Column = new long[RowCount];
            ColumnPotentials = new long[RowCount];
        }
        public void Generate(int min, int max)
        {
            Random rnd = new Random();
            for (int i = 0; i < RowCount; i++)
                for (int j = 0; j < ColCount; j++)
                    Matrix[i, j] = min + rnd.Next(max - min);
            for (int i = 0; i < ColCount; i++)
                Row[i] = (min + rnd.Next(Convert.ToInt32((max - min)))) * 10;
            for (int i = 0; i < RowCount; i++)
                Column[i] = (min + rnd.Next(Convert.ToInt32((max - min)))) * 10;
        }
        public void Balans()
        {
            long summaRow = 0, summaColumn = 0;
            for (int i = 0; i < ColCount; i++)
                summaColumn += Row[i];
            for (int i = 0; i < RowCount; i++)
                summaRow += Column[i];
            if (summaRow == summaColumn)
                return;
            if (summaColumn > summaRow)
            {
                int newRowCount = RowCount + 1;
                int newColCount = ColCount;
                long[,] newMatrix = new long[newRowCount, newColCount];
                long[] newCol = new long[newRowCount];
                Marks = new long[newRowCount, newColCount];
                MarksBoolean = new bool[newRowCount, newColCount];
                ColumnPotentials = new long[newRowCount];
                for (int i = 0; i < RowCount; i++)
                    for (int j = 0; j < ColCount; j++)
                        newMatrix[i, j] = Matrix[i, j];
                for (int j = 0; j < ColCount; j++)
                    newMatrix[RowCount, j] = int.MaxValue;
                for (int i = 0; i < RowCount; i++)
                    newCol[i] = Column[i];
                newCol[RowCount] = summaColumn - summaRow;
                Column = newCol;
                Matrix = newMatrix;
                RowCount = newRowCount;
                ColCount = newColCount;
            }
            if (summaColumn < summaRow)
            {
                int newRowCount = RowCount;
                int newColCount = ColCount + 1;
                long[,] newMatrix = new long[newRowCount, newColCount];
                long[] newRow = new long[newColCount];
                Marks = new long[newRowCount, newColCount];
                MarksBoolean = new bool[newRowCount, newColCount];
                RowPotentials = new long[newColCount];
                for (int i = 0; i < RowCount; i++)
                    for (int j = 0; j < ColCount; j++)
                        newMatrix[i, j] = Matrix[i, j];
                
                for (int i = 0; i < RowCount; i++)
                    newMatrix[i, ColCount] = int.MaxValue;
                for (int i = 0; i < ColCount; i++)
                    newRow[i] = Row[i];
                newRow[ColCount] = summaRow - summaColumn;
                Row = newRow;
                Matrix = newMatrix;
                RowCount = newRowCount;
                ColCount = newColCount;
            }
                
        }
        public void Prepare()
        {
            Balans();
            long[] row = new long[ColCount];
            long[] column = new long[RowCount];
            for (int i = 0; i < ColCount; i++)
                row[i] = Row[i];
            for (int i = 0; i < RowCount; i++)
                column[i] = Column[i];

            int posX = 0, posY = 0;
            for (int k = 0; k < RowCount + ColCount - 1; k++)
            {
                if (column[posY] == 0)
                    posY++;
                else
                    if (row[posX] == 0)
                        posX++;
                long value = Math.Min(column[posY], row[posX]);
                Marks[posY, posX] = value;
                MarksBoolean[posY, posX] = true;
                column[posY] -= value;
                row[posX] -= value;
            }
        }
        public long GetValueOfTargetFunction()
        {
            long summa = 0;
            for (int i = 0; i < SourceRowCount; i++)
                for (int j = 0; j < SourceColCount; j++)
                {
                    summa += Matrix[i, j] * Marks[i, j];
                }
            return summa;
        }
        public List<Edge> GetCurrentSolution()
        {
            List<Edge> list = new List<Edge>();
            for (int i = 0; i < SourceRowCount; i++)
                for (int j = 0; j < SourceColCount; j++)
                    if (Marks[i, j] != 0)
                        list.Add(new Edge(i, j, Marks[i, j]));
            return list;
        }
        public long this[long i, long j]
        {
            get
            {
                return Matrix[i, j];
            }
            set
            {
                Matrix[i, j] = value;
            }
        }
        public long GetLastRow(long i)
        {
            return Row[i];
        }
        public long GetLastColumn(long i)
        {
            return Column[i];
        }
        public void SetLastRow(long i, long value)
        {
            Row[i] = value;
        }
        public void SetLastColumn(long i, long value)
        {
            Column[i] = value;
        }
        public void FindPotentials()
        {
            bool[] row = new bool[ColCount];
            bool[] column = new bool[RowCount];
            row[0] = true;
            int count = 1;
            RowPotentials[0] = 0;
            while (count < RowCount + ColCount)
            {
                for (int i = 0; i < RowCount; i++)
                    for (int j = 0; j < ColCount; j++)
                    {
                        if (row[j] != column[i] && MarksBoolean[i, j])
                        {
                            if (row[j] == true && column[i] == false)
                            {
                                ColumnPotentials[i] = Matrix[i, j] - RowPotentials[j];
                                column[i] = true;
                                count++;
                            }
                            if (row[j] == false && column[i] == true)
                            {
                                RowPotentials[j] = Matrix[i, j] - ColumnPotentials[i];
                                row[j] = true;
                                count++;
                            }
                        }
                    }
            }

        }
        public Edge FindMaxMark()
        {
            long max = long.MinValue;
            Edge edge = null;
            for (int i = 0; i < RowCount; i++)
                for (int j = 0; j < ColCount; j++)
                {
                    if (MarksBoolean[i, j] == false)
                    {
                        long value;
                        value = RowPotentials[j] + ColumnPotentials[i] - Matrix[i, j];
                        if (value > max)
                        {
                            max = value;
                            edge = new Edge(i, j, value);
                        }
                    }
                }
            return edge;
        }
        public void FindCylce()
        {
            bool[,] matrix = new bool[RowCount, ColCount];
            Edge edge = FindMaxMark();
            for (int i = 0; i < RowCount; i++)
                for (int j = 0; j < ColCount; j++)
                    matrix[i, j] = MarksBoolean[i, j];
            matrix[edge.GetFirstVertex(), edge.GetSecondVertex()] = true;
            int countRow = 0, countCol = 0;
            bool f = true;
            while (f)
            {
                f = false;
                for (int i = 0; i < RowCount; i++)
                {
                    countRow = 0;
                    for (int j = 0; j < ColCount; j++)
                        if (matrix[i, j])
                            countRow++;
                    if (countRow == 1)
                    {
                        for (int j = 0; j < ColCount; j++)
                            matrix[i, j] = false;
                        f = true;
                    }
                }
                for (int j = 0; j < ColCount; j++)
                
                {
                    countCol = 0;
                    for (int i = 0; i < RowCount; i++)
                        if (matrix[i, j])
                            countCol++;
                    if (countCol == 1)
                    {
                        for (int i = 0; i < RowCount; i++)
                            matrix[i, j] = false;
                        f = true;
                    }
                }
            }
            long posX, posY;
            posY = edge.GetFirstVertex();
            posX = edge.GetSecondVertex();
            string[,] signMatrix = new string[RowCount, ColCount];
            bool sign = true; // true - знак плюс, false - минус
            signMatrix[posY, posX] = "+";
            do
            {
                for (int i = 0; i < RowCount; i++)
                    if (i != posY)
                        if (matrix[i, posX] == true)
                        {
                            posY = i;
                            break;
                        }
                signMatrix[posY, posX] = "-";
                for (int i = 0; i < ColCount; i++)
                    if (i != posX)
                        if (matrix[posY, i] == true)
                        {
                            posX = i;
                            break;
                        }
                signMatrix[posY, posX] = "+";
            } while (posY != edge.GetFirstVertex() && posX != edge.GetSecondVertex());

            long minMark = long.MaxValue;
            Edge minMarkEdge = null;
            for (int i = 0; i < RowCount; i++)
                for (int j = 0; j < ColCount; j++)
                {
                    if (signMatrix[i, j] == "-")
                    {
                        if (minMark > Marks[i, j])
                        {
                            minMark = Marks[i, j];
                            minMarkEdge = new Edge(i, j);
                        }
                    }
                }
            for (int i = 0; i < RowCount; i++)
                for (int j = 0; j < ColCount; j++)
                {
                    if (signMatrix[i, j] == "-")
                    {
                        MarksBoolean[posY, posX] = true;
                        Marks[i, j] -= minMark;
                    }
                    if (signMatrix[i, j] == "+")
                    {
                        MarksBoolean[posY, posX] = true;
                        Marks[i, j] += minMark;
                    }
                }
            MarksBoolean[minMarkEdge.GetFirstVertex(), minMarkEdge.GetSecondVertex()] = false;
        }
        public bool DoIteration()
        {
            FindPotentials();
            Edge edge = FindMaxMark();
            if (edge.GetWeight() <= 0)
            {
                return false;
            }
            FindCylce();
            return true;
        }
    }
}
