﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
//using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Collections.Generic;
using System.IO;

namespace TransportProblem
{
    public partial class Form1 : Form
    {
        protected bool Test;
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {            
            int RowCount = Convert.ToInt32(numericUpDown1.Value);
            int ColCount = Convert.ToInt32(numericUpDown2.Value);
            dataGridView1.Columns.Clear();
            dataGridView1.ColumnCount = ColCount + 1;
            dataGridView1.RowCount = RowCount + 1;
            for (int i = 0; i < ColCount; i++)
            {
                dataGridView1.Columns[i].Width = 35;
                dataGridView1.Columns[i].HeaderText = (i + 1).ToString();
            }
            for (int i = 0; i < RowCount; i++)
                dataGridView1.Rows[i].HeaderCell.Value = (i + 1).ToString();
            dataGridView1.Columns[ColCount].Width = 50;
            dataGridView1.Columns[ColCount].HeaderText = "Запаси";            
            dataGridView1.Rows[RowCount].HeaderCell.Value = "Потреби";
        }

        private void button4_Click(object sender, EventArgs e)
        {
            int RowCount = Convert.ToInt32(numericUpDown1.Value);
            int ColCount = Convert.ToInt32(numericUpDown2.Value);
            button1_Click(sender, e);
            Random rnd = new Random();
            int first, second;
            first = Convert.ToInt32(textBox1.Text);
            second = Convert.ToInt32(textBox2.Text);
            PotentialMethod pm = new PotentialMethod(RowCount, ColCount);
            pm.Generate(first, second);
            for (int i = 0; i < RowCount; i++)
                for (int j = 0; j < ColCount; j++)
                    dataGridView1[j, i].Value = pm[i,j];

            for (int i = 0; i < RowCount; i++)
                dataGridView1[ColCount, i].Value = pm.GetLastColumn(i);
            for (int i = 0; i < ColCount; i++)
                dataGridView1[i, RowCount].Value = pm.GetLastRow(i);
        }

        private void button5_Click(object sender, EventArgs e)
        {
            PotentialMethod potentialMethod = new PotentialMethod(Convert.ToInt32(numericUpDown1.Value), Convert.ToInt32(numericUpDown2.Value));
            int RowCount = Convert.ToInt32(numericUpDown1.Value);
            int ColCount = Convert.ToInt32(numericUpDown2.Value);
            for (int i = 0; i < RowCount; i++)
                for (int j = 0; j < ColCount; j++)
                {
                    if (dataGridView1[j, i].Value != null)
                        potentialMethod[i, j] = Convert.ToInt32(dataGridView1[j, i].Value);
                    else
                        potentialMethod[i, j] = 0;
                }
            for (int i = 0; i < RowCount; i++)
                potentialMethod.SetLastColumn(i, Convert.ToInt32(dataGridView1[ColCount, i].Value));
            for (int i = 0; i < ColCount; i++)
                potentialMethod.SetLastRow(i, Convert.ToInt32(dataGridView1[i, RowCount].Value));
            potentialMethod.Prepare();
            List<Edge> list = potentialMethod.GetCurrentSolution();
            String s = "";
            Form2 frm = new Form2();
            frm.dataGridView1.Columns.Clear();
            frm.dataGridView1.Columns.Add("", "Пост.");
            frm.dataGridView1.Columns.Add("", "Спож.");
            frm.dataGridView1.Columns.Add("", "К-ть од. прод.");
            frm.dataGridView1.Columns.Add("", "Заг. варт.");
            frm.dataGridView1.Columns[0].Width = 40;
            frm.dataGridView1.Columns[1].Width = 40;
            frm.dataGridView1.Columns[2].Width = 70;
            frm.dataGridView1.Columns[3].Width = 100;            
            frm.dataGridView1.RowCount = list.Count;
            frm.textBox3.Text = potentialMethod.GetValueOfTargetFunction().ToString();
            int index = 0;
            foreach (Edge edge in list)
            {
                frm.dataGridView1[0, index].Value = (edge.GetFirstVertex() + 1).ToString();
                frm.dataGridView1[1, index].Value = (edge.GetSecondVertex() + 1).ToString();
                frm.dataGridView1[2, index].Value = edge.GetWeight().ToString();
                frm.dataGridView1[3, index].Value = (edge.GetWeight() * potentialMethod[edge.GetFirstVertex(), edge.GetSecondVertex()]).ToString();
                index++;
            }
            while (potentialMethod.DoIteration())
            {
            }
            list = potentialMethod.GetCurrentSolution();
            frm.dataGridView2.Columns.Clear();
            frm.dataGridView2.Columns.Add("", "Пост.");
            frm.dataGridView2.Columns.Add("", "Спож.");
            frm.dataGridView2.Columns.Add("", "К-ть од. прод.");
            frm.dataGridView2.Columns.Add("", "Заг. варт.");
            frm.dataGridView2.Columns[0].Width = 40;
            frm.dataGridView2.Columns[1].Width = 40;
            frm.dataGridView2.Columns[2].Width = 70;
            frm.dataGridView2.Columns[3].Width = 100;
            frm.dataGridView2.RowCount = list.Count;
            frm.textBox6.Text = potentialMethod.GetValueOfTargetFunction().ToString();
            index = 0;
            foreach (Edge edge in list)
            {
                frm.dataGridView2[0, index].Value = (edge.GetFirstVertex() + 1).ToString();
                frm.dataGridView2[1, index].Value = (edge.GetSecondVertex() + 1).ToString();
                frm.dataGridView2[2, index].Value = edge.GetWeight().ToString();
                frm.dataGridView2[3, index].Value = (edge.GetWeight() * potentialMethod[edge.GetFirstVertex(), edge.GetSecondVertex()]).ToString();
                index++;
            }            
            frm.ShowDialog();
        }

        private void button3_Click(object sender, EventArgs e)
        {
            DialogResult res = saveFileDialog1.ShowDialog();
            if (res == DialogResult.OK)
            {
                FileStream file = new FileStream(saveFileDialog1.FileName, FileMode.Create);
                BinaryWriter writer = new BinaryWriter(file);
                writer.Write(dataGridView1.ColumnCount);
                writer.Write(dataGridView1.RowCount);
                for (int i = 0; i < dataGridView1.RowCount; i++)
                    for (int j = 0; j < dataGridView1.ColumnCount; j++)
                    {
                        if (dataGridView1[j, i].Value != null)
                            writer.Write(dataGridView1[j, i].Value.ToString());
                        else
                            writer.Write("");
                    }
                writer.Close();
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            DialogResult res = openFileDialog1.ShowDialog();
            if (res == DialogResult.OK)
            {
                FileStream file = new FileStream(openFileDialog1.FileName, FileMode.Open);
                BinaryReader reader = new BinaryReader(file);
                dataGridView1.ColumnCount = reader.ReadInt32();
                dataGridView1.RowCount = reader.ReadInt32();
                numericUpDown2.Value = dataGridView1.ColumnCount - 1;
                numericUpDown1.Value = dataGridView1.RowCount - 1;
                button1_Click(sender, e);
                for (int i = 0; i < dataGridView1.RowCount; i++)
                    for (int j = 0; j < dataGridView1.ColumnCount; j++)
                    {
                        dataGridView1[j, i].Value = reader.ReadString();
                    }
                reader.Close();
            }

        }

        private void button6_Click(object sender, EventArgs e)
        {
            dataGridView2.Columns.Clear();
            dataGridView2.Columns.Add("", "Похибка");
            dataGridView2.Columns.Add("", "Час наближеного");
            dataGridView2.Columns.Add("", "Час точного");
            dataGridView2.RowCount = (Convert.ToInt32(razm2.Text) - Convert.ToInt32(razm1.Text)) / Convert.ToInt32(interval.Text) +  1;            
            button6.Enabled = false;
            button7.Enabled = true;
            Test = true;
            TimeSpan timeSpan = new TimeSpan();
            DateTime timer;
            int numRow = 0;
            for (int razm = Convert.ToInt32(razm1.Text); razm <= Convert.ToInt32(razm2.Text); razm += Convert.ToInt32(interval.Text))
            {
                float approx, exact, k = 0;
                float tst = Convert.ToSingle(testCount.Value);
                dataGridView2.Rows[numRow].HeaderCell.Value = razm.ToString();
                if (checkBox3.Checked == true)
                {
                    for (int i = 0; i < testCount.Value; i++)
                    {
                        PotentialMethod potentialMethod = new PotentialMethod(razm, razm);
                        potentialMethod.Generate(Convert.ToInt32(diap1.Text), Convert.ToInt32(diap2.Text));
                        potentialMethod.Prepare();
                        approx = potentialMethod.GetValueOfTargetFunction();
                        while (potentialMethod.DoIteration()) ;
                        exact = potentialMethod.GetValueOfTargetFunction();
                        k = Math.Max(approx / exact, k);
                        Application.DoEvents();
                        if (!Test)
                            return;
                    }                    
                    dataGridView2[0, numRow].Value = k.ToString();
                }
                if (checkBox2.Checked == true)
                {
                    timer = DateTime.Now;
                    for (int i = 0; i < testCount.Value; i++)
                    {
                        PotentialMethod potentialMethod = new PotentialMethod(razm, razm);
                        potentialMethod.Generate(Convert.ToInt32(diap1.Text), Convert.ToInt32(diap2.Text));
                        potentialMethod.Prepare();
                        Application.DoEvents();
                        if (!Test)
                            return;
                    }
                    timeSpan = DateTime.Now - timer;
                    dataGridView2[1, numRow].Value = ((timeSpan.Minutes * 60 + timeSpan.Seconds) / tst).ToString();
                }
                if (checkBox1.Checked == true)
                {
                    timer = DateTime.Now;
                    for (int i = 0; i < testCount.Value; i++)
                    {
                        PotentialMethod potentialMethod = new PotentialMethod(razm, razm);
                        potentialMethod.Generate(Convert.ToInt32(diap1.Text), Convert.ToInt32(diap2.Text));
                        potentialMethod.Prepare();
                        while (potentialMethod.DoIteration()) ;
                        Application.DoEvents();
                        if (!Test)
                            return;
                    }
                    timeSpan = DateTime.Now - timer;
                    dataGridView2[2, numRow].Value = ((timeSpan.Minutes * 60 + timeSpan.Seconds) / tst).ToString();
                }
                this.Refresh();
                Application.DoEvents();
                if (!Test)
                    return;
                numRow++;
            }
            button6.Enabled = true;
            button7.Enabled = false;
        }

        private void button7_Click(object sender, EventArgs e)
        {

        }

        private void button7_Click_1(object sender, EventArgs e)
        {
            button6.Enabled = true;
            button7.Enabled = false;
            Test = false;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            Test = false;
        }

        private void Form1_Click(object sender, EventArgs e)
        {
            Test = false;
        }

        private void Form1_KeyPress(object sender, KeyPressEventArgs e)
        {
            Test = false;
        }

        private void timer1_Tick(object sender, EventArgs e)
        {

        }

        private void toolTip1_Draw(object sender, DrawToolTipEventArgs e)
        {
        }

        private void label2_Click(object sender, EventArgs e)
        {

        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {

        }

        private void label3_Click(object sender, EventArgs e)
        {

        }

        private void textBox2_TextChanged(object sender, EventArgs e)
        {

        }

        private void label1_Click(object sender, EventArgs e)
        {

        }

        private void numericUpDown1_ValueChanged(object sender, EventArgs e)
        {

        }

        private void numericUpDown2_ValueChanged(object sender, EventArgs e)
        {

        }
    }
}
